using System;
using System.Net;
using System.Net.Http.Headers;

namespace cloud.insecurity.http
{
    public class HttpResponse : IHttpResponse
    {
        internal HttpRequest Request;

        public WebHeaderCollection Headers = new WebHeaderCollection()
        {
            {"Server", "insecurity"}, 
        };
        public HttpResponse(HttpRequest request)
        {
            Request = request;
        }
        public void Dispose()
        {
            DefaultHttpResponse.New(Request.Context).Dispose();
        }

        public IHttpResponse SendResponse()
        {
            return DefaultHttpResponse.New(Request.Context)
                .SendResponse();
        }

        public IHttpResponse NotFound()
        {
            return DefaultHttpResponse.New(Request.Context)
                .NotFound();
        }

        public IHttpResponse InternalServerError()
        {
            return DefaultHttpResponse.New(Request.Context)
                .InternalServerError();
        }

        public IHttpResponse NotImplemented()
        {
            return DefaultHttpResponse.New(Request.Context)
                .NotImplemented();
        }

        public IHttpResponse Ok()
        {
            return DefaultHttpResponse
                .New(Request.Context)
                .Ok();
        }
    }
}