using System;
using System.Net;

namespace cloud.insecurity.http
{
    public interface IHttpResponse : IDisposable
    {
        public enum ResponseCodes
        {
            Continue = 100,
            SwitchingProtocols = 101,
            ProcessingRfc2518 = 102,
            EarlyHints = 103,
            Ok = 200,
            Created = 201,
            Accepted = 202,
            NonAuthoritativeInformation = 203,
            NoContent = 204,
            ResetContent = 205,
            PartialContent = 206,
            MultiStatus = 207,
            AlreadyReported = 208,
            ImUsed = 226,
            MultipleChoices = 300,
            MovedPermanently = 301,
            SeeOther = 303,
            NotModified = 304,
            UseProxy = 305,
            TemporaryRedirect = 307,
            PermanentRedirect = 308,
            BadRequest = 400,
            PaymentRequired = 402,
            NotFound = 404,
            MethodNot = 405,
            NotAcceptable = 406,
            ProxyAuthentication = 407,
            RequestTimeout = 408,
            LengthRequired = 411,
            PreconditionFailed = 412,
            ContentToo = 413,
            UriToo = 414,
            UnsupportedMedia = 415,
            RangeNot = 416,
            ExpectationFailed = 417,
            MisdirectedRequest = 421,
            UnprocessableContent = 422,
            LockedRfc4918 = 423,
            FailedDependency = 424,
            TooEarly = 425,
            UpgradeRequired = 426,
            Unassigned1 = 427,
            PreconditionRequired = 428,
            TooMany = 429,
            Unassigned2 = 430,
            RequestHeader = 431,
            UnavailableFor = 451,
            InternalServerError = 500,
            NotImplemented = 501,
            BadGateway = 502,
            ServiceUnavailable = 503,
            GatewayTimeout = 504,
            HttpVersion = 505,
            VariantAlso = 506,
            InsufficientStorage = 507,
            LoopDetected = 508,
            Unassigned = 509,
            NotExtended = 510,
            NetworkAuthentication = 511,
        }
        public IHttpResponse SendResponse();
        public IHttpResponse NotFound();
        public IHttpResponse InternalServerError();
        public IHttpResponse NotImplemented();
        public IHttpResponse Ok();
    }
}